DIRNAME=`dirname $0`

SERVER_HOME=$DIRNAME/..
export SERVER_HOME

DB_HOME=$SERVER_HOME/mysql
export DB_HOME

if test -d $SERVER_HOME/jre
then
	JAVA_HOME=$SERVER_HOME/jre
	export JAVA_HOME
fi



if [ "x$JAVA" = "x" ]; then
	if [ "x$JAVA_HOME" != "x" ]; then
		JAVA="$JAVA_HOME/bin/java"
	else
		JAVA=`which java`
	fi
fi



DB_PORT=33336
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$SERVER_HOME/lib

export DB_PORT
export LD_LIBRARY_PATH

# <--------------------- Setting JAVA_OPTS command Block ----------------------->
# INSTRUCTIONS:
# ------------
#  FOR BINDING THE APPLICATION TO SINGLE INTERFACE, uncomment the below JAVA_OPTS setting command and replace <ip-address> with the ip-address to which you wants to bind the application and comment the existing JAVA_OPTS setting command.

#JAVA_OPTS="-Djava.awt.headless=true -DpdfReport=false -Duser.language=en -Duser.country=US -DminDiskSpace=5 -Djava.library.path=../lib:../lib/native -Xms128m -Xmx512m -Dspecific.bind.address=<ip-address>"

JAVA_OPTS="-Djava.awt.headless=true -DpdfReport=false -Duser.language=en -Duser.country=US -DminDiskSpace=5 -Djava.library.path=../lib:../lib/native -Xms256m -Xmx1024m"
export JAVA_OPTS

# temporarily the common variables are set here... these have to be moved to build time...
PRODUCT="Firewall Analyzer"
export PRODUCT
APP_NAME_VALUE=firewallanalyzer
export APP_NAME_VALUE
APP_LONG_NAME_VALUE="ManageEngine Firewall Analyzer"
export APP_LONG_NAME_VALUE
SERVICE_NAME=firewallanalyzer
export SERVICE_NAME
MAX_SERVICE_ID=`ls /etc/rc6.d/ -1 | grep "^K" | tail -1 | cut -c 2,3`
SERVICE_ID=`expr $MAX_SERVICE_ID - 10`
export SERVICE_ID

#fix for UpdateManager.sh
PATH=$JAVA_HOME/bin:$PATH:.


