# !/bin/sh
### ====================================================================== ###
##                                                                          ##
## startDB.sh  <DB_HOME> <DB_PORT>
##                                                                          ##
### ====================================================================== ###

DIRNAME=$PWD
DB_PORT=$1
TMP_HOME=$2

if [ -d "$DIRNAME/../mysql" ]
then
   DB_HOME=$DIRNAME/../mysql
elif [ -d "$DIRNAME/mysql" ]
then
   DB_HOME=$DIRNAME/mysql
else
    DB_HOME=$TMP_HOME/../mysql 
fi


if [ -z "$DB_PORT" ]
then
        echo "Database is automatically started by the server. This is only for troubleshooting. Do you still want to continue (y/n)?" 
        read input
	if [ "$input" != "y" ]
	then	
	exit 1
	fi
        if [ -z "$DB_HOME" ]
        then
        DB_HOME=$DIRNAME/../mysql
        fi
        if [ -z "$DB_PORT" ]
        then
        DB_PORT=33336
        fi
        if [ -z "$TMP_HOME" ]
        then
        TMP_HOME=$DIRNAME/../mysql/tmp
        fi
fi
chmod -R u+x $DB_HOME

#<-------------------- MYSQL Start Command Block -------------------->
#INSTRUCTIONS:
#------------
# FOR BINDING THE APPLICATION TO SINGLE INTERFACE, uncomment the below start command and replace <ip-address> with the ip-address to which you wants to bind the application and comment all other start commands.

#$DB_HOME/bin/mysqld --no-defaults --basedir=$DB_HOME --port=$DB_PORT --tmpdir=$TMP_HOME --socket=$TMP_HOME/mysql.sock --user=root  --innodb_buffer_pool_size=180M --key_buffer_size=32M --innodb_file_per_table --max_heap_table_size=32M --tmp_table_size=40M --innodb_flush_log_at_trx_commit=0 --log-error --table-cache=256 --bind-address=<ip-address> &

#default
$DB_HOME/bin/mysqld --no-defaults --basedir=$DB_HOME --port=$DB_PORT --tmpdir=$TMP_HOME --socket=$TMP_HOME/mysql.sock --user=root  --innodb_buffer_pool_size=180M --key_buffer_size=32M --innodb_file_per_table --max_heap_table_size=32M --tmp_table_size=40M --innodb_flush_log_at_trx_commit=0 --log-error --table-cache=256 &

#uncomment this for 1 GB RAM
#$DB_HOME/bin/mysqld --no-defaults --basedir=$DB_HOME --port=$DB_PORT --tmpdir=$TMP_HOME --socket=$TMP_HOME/mysql.sock --user=root  --innodb_buffer_pool_size=300M --key_buffer_size=150M --innodb_file_per_table --max_heap_table_size=150M --tmp_table_size=100M --innodb_flush_log_at_trx_commit=0 --log-error --table-cache=512 &

#uncomment this for 2 GB RAM
#$DB_HOME/bin/mysqld --no-defaults --basedir=$DB_HOME --port=$DB_PORT --tmpdir=$TMP_HOME --socket=$TMP_HOME/mysql.sock --user=root  --innodb_buffer_pool_size=900M --key_buffer_size=600M --innodb_file_per_table --max_heap_table_size=350M --tmp_table_size=100M --innodb_flush_log_at_trx_commit=0 --log-error --table-cache=512 &

#uncomment this for 3GB
#$DB_HOME/bin/mysqld --no-defaults --basedir=$DB_HOME --port=$DB_PORT --tmpdir=$TMP_HOME --socket=$TMP_HOME/mysql.sock --user=root  --innodb_buffer_pool_size=1400M --key_buffer_size=1000M --innodb_file_per_table --max_heap_table_size=350M --tmp_table_size=100M --innodb_flush_log_at_trx_commit=0 --log-error --table-cache=512 &

#uncomment this for 4GB.
#$DB_HOME/bin/mysqld --no-defaults --basedir=$DB_HOME --port=$DB_PORT --tmpdir=$TMP_HOME --socket=$TMP_HOME/mysql.sock --user=root  --innodb_buffer_pool_size=1800M --key_buffer_size=1200M --innodb_file_per_table --max_heap_table_size=350M --tmp_table_size=100M --innodb_flush_log_at_trx_commit=0 --log-error --table-cache=512 &


