insert into SystemConfigurations values ('regenerateSQL','true');

drop table if exists FirewallRecords_Tmp;
drop table if exists ReportBuildingBlock_Temp;
drop table if exists ReportBuildingBlock_7400;
drop table if exists ReportBuildingBlockParams_7400;
drop table if exists ReportBuildingBlockColumn_7400;
drop table if exists RBBGraphOptions_7400;


create table ReportBuildingBlock_Temp like ReportBuildingBlock;
alter table ReportBuildingBlock_Temp ADD RBBGNAME VARCHAR(250) default NULL;
load data local infile '${location}/ReportBuildingBlock_temp.txt' into table ReportBuildingBlock_Temp;
alter table ReportBuildingBlock_Temp modify ORDERID bigint(19) AUTO_INCREMENT; 
insert into ReportBuildingBlock_Temp (RBBNAME,SQLSTRING,RBBGID,DISPLAYTYPE,HANDLER,TITLE,DESCRIPTION,JASPERNAME,SQLTYPE,RBBGNAME) select ReportBuildingBlock.RBBNAME,ReportBuildingBlock.SQLSTRING,ReportBuildingBlock.RBBGID,ReportBuildingBlock.DISPLAYTYPE,ReportBuildingBlock.HANDLER,ReportBuildingBlock.TITLE,ReportBuildingBlock.DESCRIPTION,ReportBuildingBlock.JASPERNAME,ReportBuildingBlock.SQLTYPE,ReportBuildingBlockGroup.RBBGNAME from ReportBuildingBlock inner join ReportBuildingBlockGroup on ReportBuildingBlock.RBBGID=ReportBuildingBlockGroup.RBBGID where (ReportBuildingBlock.RBBNAME like "% Table%" or ReportBuildingBlock.RBBNAME like "% Graph%" or ReportBuildingBlock.RBBNAME like "%_anomaly" or ReportBuildingBlockGroup.RBBGNAME="Proxy Virus Drill Down" or ReportBuildingBlockGroup.RBBGNAME="Security View Squid Drill and Others" or ReportBuildingBlockGroup.RBBGNAME='Squid Security report view') and (ReportBuildingBlock.RBBNAME NOT like "Event Distribution Graph");
insert into ReportBuildingBlock_Temp (RBBNAME,SQLSTRING,RBBGID,DISPLAYTYPE,HANDLER,TITLE,DESCRIPTION,JASPERNAME,SQLTYPE,RBBGNAME) select ReportBuildingBlock.RBBNAME,ReportBuildingBlock.SQLSTRING,ReportBuildingBlock.RBBGID,ReportBuildingBlock.DISPLAYTYPE,ReportBuildingBlock.HANDLER,ReportBuildingBlock.TITLE,ReportBuildingBlock.DESCRIPTION,ReportBuildingBlock.JASPERNAME,ReportBuildingBlock.SQLTYPE,ReportBuildingBlockGroup.RBBGNAME from ReportBuildingBlock inner join ReportBuildingBlockGroup on ReportBuildingBlock.RBBGID = ReportBuildingBlockGroup.RBBGID inner join ReportConfigToRBBGMapping on ReportConfigToRBBGMapping.RBBGID = ReportBuildingBlockGroup.RBBGID inner join ReportConfig on ReportConfig.REPORTID = ReportConfigToRBBGMapping.REPORTID where ReportConfig.REPORTTYPE='FW_SEARCH';
create table ReportBuildingBlock_7600 like ReportBuildingBlock;
insert into ReportBuildingBlock_7600 select ReportBuildingBlock_Temp.RBBNAME, ReportBuildingBlock_Temp.SQLSTRING,ReportBuildingBlockGroup.RBBGID,ReportBuildingBlock_Temp.DISPLAYTYPE,ReportBuildingBlock_Temp.HANDLER,ReportBuildingBlock_Temp.TITLE,ReportBuildingBlock_Temp.DESCRIPTION,ReportBuildingBlock_Temp.JASPERNAME,ReportBuildingBlock_Temp.ORDERID,ReportBuildingBlock_Temp.SQLTYPE from ReportBuildingBlock_Temp inner join ReportBuildingBlockGroup on ReportBuildingBlockGroup.RBBGNAME = ReportBuildingBlock_Temp.RBBGNAME;
set foreign_key_checks=0;
create table ReportBuildingBlock_7400 like ReportBuildingBlock;
insert into ReportBuildingBlock_7400 select * from ReportBuildingBlock;
drop table ReportBuildingBlock;
RENAME table ReportBuildingBlock_7600 To ReportBuildingBlock;
set foreign_key_checks=1;
alter table ReportBuildingBlock add CONSTRAINT ReportBuildingBlock_FK1 FOREIGN KEY (RBBGID) REFERENCES ReportBuildingBlockGroup (RBBGID) ON DELETE CASCADE;


create table RBBGraphOptions_Temp like RBBGraphOptions;
create table ReportBuildingBlockParams_Temp like ReportBuildingBlockParams;
alter table ReportBuildingBlockParams_Temp modify RBBPID bigint(19) AUTO_INCREMENT;
load data local infile '${location}/RBBGraphOptions_temp.txt' into table RBBGraphOptions_Temp;
load data local infile '${location}/ReportBuildingBlockParams_temp.txt' into table ReportBuildingBlockParams_Temp;
load data local infile '${location}/ReportBuildingBlockColumn_temp.txt' into table ReportBuildingBlockColumn_Temp;


insert into ReportBuildingBlockParams_Temp (RBBNAME,PARAMSQL) select ReportBuildingBlockParams.RBBNAME,ReportBuildingBlockParams.PARAMSQL from ReportBuildingBlockParams inner join ReportBuildingBlock on ReportBuildingBlock.RBBNAME=ReportBuildingBlockParams.RBBNAME inner join ReportBuildingBlockGroup on ReportBuildingBlockGroup.RBBGID = ReportBuildingBlock.RBBGID inner join ReportConfigToRBBGMapping on ReportConfigToRBBGMapping.RBBGID = ReportBuildingBlockGroup.RBBGID inner join ReportConfig on ReportConfig.REPORTID = ReportConfigToRBBGMapping.REPORTID where ReportConfig.REPORTTYPE='FW_SEARCH';
alter table ReportBuildingBlockColumn_Temp MODIFY RBBCID bigint(19) NOT NULL;
alter table ReportBuildingBlockParams_Temp MODIFY RBBPID bigint(19) NOT NULL;
alter table ReportBuildingBlock_Temp MODIFY ORDERID bigint(19) NOT NULL;


set foreign_key_checks=0;
create table ReportBuildingBlockParams_7400 like ReportBuildingBlockParams;
insert into ReportBuildingBlockParams_7400 select * from ReportBuildingBlockParams;
drop table ReportBuildingBlockParams;
RENAME table ReportBuildingBlockParams_Temp To ReportBuildingBlockParams;

create table ReportBuildingBlockColumn_7400 like ReportBuildingBlockColumn;
insert into ReportBuildingBlockColumn_7400 select * from ReportBuildingBlockColumn;
drop table ReportBuildingBlockColumn;
RENAME table ReportBuildingBlockColumn_Temp To ReportBuildingBlockColumn;

create table RBBGraphOptions_7400 like RBBGraphOptions;
insert into RBBGraphOptions_7400 select * from RBBGraphOptions;
drop table RBBGraphOptions;
RENAME table RBBGraphOptions_Temp To RBBGraphOptions;


alter table ReportBuildingBlockParams add CONSTRAINT ReportBuildingBlockParams_FK1 FOREIGN KEY (RBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE;
alter table RBBGraphOptions add CONSTRAINT RBBGraphOptions_FK1 FOREIGN KEY (RBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE, add CONSTRAINT RBBGraphOptions_FK2 FOREIGN KEY (LINKINGRBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE,add CONSTRAINT RBBGraphOptions_FK3 FOREIGN KEY (LINKINGRBBGNAME) REFERENCES ReportBuildingBlockGroup (RBBGNAME) ON DELETE CASCADE;
alter table ReportBuildingBlockColumn add CONSTRAINT ReportBuildingBlockColumn_FK FOREIGN KEY (RBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE;
set foreign_key_checks=1;
insert into RBBGraphOptions select * from RBBGraphOptions_7400 where (RBBGraphOptions_7400.RBBNAME like "% Table%" or RBBGraphOptions_7400.RBBNAME like "% Graph%" or RBBGraphOptions_7400.RBBNAME like "%_anomaly") and (RBBGraphOptions_7400.RBBNAME NOT like "Event Distribution Graph");
alter table RBBColumnOptions drop FOREIGN KEY RBBColumnOptions_FK;

alter table RBBColumnOptions add CONSTRAINT RBBColumnOptions_FK FOREIGN KEY (RBBCID) references ReportBuildingBlockColumn (RBBCID) on DELETE CASCADE;
drop table if exists ReportBuildingBlock_Temp;


## Add your 7600 queries...

insert into SystemConfigurations values ('indexTrafficLog','false');
alter table FAArchivedFiles ADD INDEXALL_STATUS bigint(19) NOT NULL default 0;

alter table ImportedLogs add FTPPORT int(10);
update ImportedLogs SET FTPPORT=21 where LOG_TYPE like 'remote';
update SystemConfigurations SET CONF_VALUE='10' where CONF_NAME='pdfRowCount' AND CONF_VALUE=100;

drop table if exists mapDummy;
create table mapDummy as select LoginToDomainMapping.LOGINID,DiscoveredDomains.NAME from LoginToDomainMapping inner join DiscoveredDomains on LoginToDomainMapping.DOMAINID=DiscoveredDomains.DID;
update AaaLogin,mapDummy set AaaLogin.DOMAINNAME=mapDummy.NAME where AaaLogin.LOGIN_ID=mapDummy.LOGINID;
drop table mapDummy;

INSERT INTO AAARadiusConfig SELECT RADIUS_IP,RADIUS_AUTH_PORT,AUTH_TYPE,RADIUS_SECRET,AUTH_RETRIES FROM RadiusServerSettings;
INSERT INTO ActiveDirectoryInfo(AD_ID,SERVERNAME,DEFAULTDOMAIN,USERNAME,PASSWORD) SELECT AD_ID,SERVERNAME,DEFAULTDOMAIN,USERNAME,PASSWORD FROM LAActiveDirectoryInfo;

update TaskEngine_Task set CLASS_NAME='com.me.tools.zcutil.mickeylite.MickeLiteZCSchedule' where TASK_NAME='METrackWorkFlow';

ALTER TABLE ReportBuildingBlockGroup DROP CRID;
ALTER TABLE Bookmark DROP CRID;
ALTER TABLE Portlet DROP CRID;


update SeqGenState set CURRENTBATCHEND=(select MAX(ORDERID)+300 from ReportBuildingBlock) where SEQNAME="ReportBuildingBlock.ORDERID";
update SeqGenState set CURRENTBATCHEND=(select MAX(RBBPID)+300 from ReportBuildingBlockParams) where SEQNAME="ReportBuildingBlockParams.RBBPID";
update SeqGenState set CURRENTBATCHEND=(select MAX(RBBCID)+300 from ReportBuildingBlockColumn) where SEQNAME="ReportBuildingBlockColumn.RBBCID";
