INSERT INTO SystemConfigurations VALUES ('regenerateSQL','true');

IF EXISTS(SELECT * FROM sysobjects WHERE name='FirewallRecords_Tmp') DROP TABLE FirewallRecords_Tmp;
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlock_Temp') DROP TABLE ReportBuildingBlock_Temp;
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlockParams_Temp') DROP TABLE ReportBuildingBlockParams_Temp;
IF EXISTS(SELECT * FROM sysobjects WHERE name='RBBGraphOptions_Temp') DROP TABLE RBBGraphOptions_Temp;
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlock_7400') DROP TABLE ReportBuildingBlock_7400;
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlockParams_7400') DROP TABLE ReportBuildingBlockParams_7400;
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlockColumn_7400') DROP TABLE ReportBuildingBlockColumn_7400;
IF EXISTS(SELECT * FROM sysobjects WHERE name='RBBGraphOptions_7400') DROP TABLE RBBGraphOptions_7400;


#########  ReportBuildingBlock Handling #########

CREATE TABLE ReportBuildingBlock_Temp ( "RBBNAME" nvarchar(250) PRIMARY KEY NOT NULL,  "SQLSTRING" ntext, "RBBGID" bigint NOT NULL, "DISPLAYTYPE" nvarchar(250) NOT NULL DEFAULT 'BOTH', "HANDLER" nvarchar(250) DEFAULT NULL, "TITLE" nvarchar(2000) DEFAULT NULL, "DESCRIPTION" nvarchar(2000) DEFAULT NULL, "JASPERNAME" nvarchar(250) DEFAULT NULL, "ORDERID" bigint IDENTITY, "SQLTYPE" int NOT NULL DEFAULT 0, "RBBGNAME" nvarchar(250) default NULL);

bcp.exe ${dbName}.dbo.ReportBuildingBlock_Temp IN ${location}/ReportBuildingBlock_mssql_temp.txt -S ${dbServer} -U ${userName} -P "${pwd}" -t "|**|" -r "|**|**|" -c -E;

insert into ReportBuildingBlock_Temp (RBBNAME,SQLSTRING,RBBGID,DISPLAYTYPE,HANDLER,TITLE,DESCRIPTION,JASPERNAME,SQLTYPE,RBBGNAME) select ReportBuildingBlock.RBBNAME,ReportBuildingBlock.SQLSTRING,ReportBuildingBlock.RBBGID,ReportBuildingBlock.DISPLAYTYPE,ReportBuildingBlock.HANDLER,ReportBuildingBlock.TITLE,ReportBuildingBlock.DESCRIPTION,ReportBuildingBlock.JASPERNAME,ReportBuildingBlock.SQLTYPE,ReportBuildingBlockGroup.RBBGNAME from ReportBuildingBlock inner join ReportBuildingBlockGroup on ReportBuildingBlock.RBBGID=ReportBuildingBlockGroup.RBBGID where (ReportBuildingBlock.RBBNAME like '% Table%' or ReportBuildingBlock.RBBNAME like '% Graph%' or ReportBuildingBlock.RBBNAME like '%_anomaly' or ReportBuildingBlockGroup.RBBGNAME='Proxy Virus Drill Down' or ReportBuildingBlockGroup.RBBGNAME='Security View Squid Drill and Others' or ReportBuildingBlockGroup.RBBGNAME='Squid Security report view') and (ReportBuildingBlock.RBBNAME NOT like 'Event Distribution Graph');


insert into ReportBuildingBlock_Temp (RBBNAME,SQLSTRING,RBBGID,DISPLAYTYPE,HANDLER,TITLE,DESCRIPTION,JASPERNAME,SQLTYPE,RBBGNAME) select ReportBuildingBlock.RBBNAME,ReportBuildingBlock.SQLSTRING,ReportBuildingBlock.RBBGID,ReportBuildingBlock.DISPLAYTYPE,ReportBuildingBlock.HANDLER,ReportBuildingBlock.TITLE,ReportBuildingBlock.DESCRIPTION,ReportBuildingBlock.JASPERNAME,ReportBuildingBlock.SQLTYPE,ReportBuildingBlockGroup.RBBGNAME from ReportBuildingBlock inner join ReportBuildingBlockGroup on ReportBuildingBlock.RBBGID = ReportBuildingBlockGroup.RBBGID inner join ReportConfigToRBBGMapping on ReportConfigToRBBGMapping.RBBGID = ReportBuildingBlockGroup.RBBGID inner join ReportConfig on ReportConfig.REPORTID = ReportConfigToRBBGMapping.REPORTID where ReportConfig.REPORTTYPE='FW_SEARCH';


IF NOT EXISTS (SELECT * FROM sysobjects WHERE name='ReportBuildingBlock_7400' AND xtype='U') SELECT * INTO ReportBuildingBlock_7400 FROM ReportBuildingBlock WHERE 1=0;
IF NOT EXISTS (SELECT * FROM sysobjects WHERE name='ReportBuildingBlock_7600' AND xtype='U') SELECT * INTO ReportBuildingBlock_7600 FROM ReportBuildingBlock WHERE 1=0;


insert into ReportBuildingBlock_7400 select * FROM ReportBuildingBlock;
insert into ReportBuildingBlock_7600 select ReportBuildingBlock_Temp.RBBNAME, ReportBuildingBlock_Temp.SQLSTRING,ReportBuildingBlockGroup.RBBGID,ReportBuildingBlock_Temp.DISPLAYTYPE,ReportBuildingBlock_Temp.HANDLER,ReportBuildingBlock_Temp.TITLE,ReportBuildingBlock_Temp.DESCRIPTION,ReportBuildingBlock_Temp.JASPERNAME,ReportBuildingBlock_Temp.ORDERID,ReportBuildingBlock_Temp.SQLTYPE from ReportBuildingBlock_Temp inner join ReportBuildingBlockGroup on ReportBuildingBlockGroup.RBBGNAME = ReportBuildingBlock_Temp.RBBGNAME;


######### DROP CONSTRAINTs ################
ALTER TABLE ReportBuildingBlock DROP CONSTRAINT ReportBuildingBlock_FK1;
ALTER TABLE ReportBuildingBlockParams DROP CONSTRAINT ReportBuildingBlockParams_FK1;
ALTER TABLE ReportBuildingBlockColumn DROP CONSTRAINT ReportBuildingBlockColumn_FK;
ALTER TABLE RBBGraphOptions DROP CONSTRAINT RBBGraphOptions_FK1;
ALTER TABLE RBBGraphOptions DROP CONSTRAINT RBBGraphOptions_FK2;
ALTER TABLE RBBColumnOptions DROP CONSTRAINT RBBColumnOptions_FK;
ALTER TABLE ReportConfigToRBBMapping DROP CONSTRAINT ReportConfigToRBB_FK2;
ALTER TABLE ReportConfigToRBBPMapping DROP CONSTRAINT ReportConfigToRBBP_FK2;
ALTER TABLE AFToRBB DROP CONSTRAINT AFToRBB_FK2;



IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlock') TRUNCATE TABLE ReportBuildingBlock;
INSERT INTO ReportBuildingBlock SELECT * FROM ReportBuildingBlock_7600;	
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlock_7600') DROP TABLE ReportBuildingBlock_7600;
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlock_Temp') DROP TABLE ReportBuildingBlock_Temp;



#########  ReportBuildingBlockParams Handling #########

CREATE TABLE ReportBuildingBlockParams_Temp ( "RBBPID" bigint DEFAULT NULL, "RBBNAME" nvarchar(250) NOT NULL, "PARAMSQL" ntext);

bcp.exe ${dbName}.dbo.ReportBuildingBlockParams_Temp IN ${location}/ReportBuildingBlockParams_mssql_temp.txt -S ${dbServer} -U ${userName} -P "${pwd}" -t "|**|" -r "|**|**|" -c;

insert into ReportBuildingBlockParams_Temp (RBBNAME,PARAMSQL) select ReportBuildingBlockParams.RBBNAME,ReportBuildingBlockParams.PARAMSQL from ReportBuildingBlockParams inner join ReportBuildingBlock on ReportBuildingBlock.RBBNAME=ReportBuildingBlockParams.RBBNAME inner join ReportBuildingBlockGroup on ReportBuildingBlockGroup.RBBGID = ReportBuildingBlock.RBBGID inner join ReportConfigToRBBGMapping on ReportConfigToRBBGMapping.RBBGID = ReportBuildingBlockGroup.RBBGID inner join ReportConfig on ReportConfig.REPORTID = ReportConfigToRBBGMapping.REPORTID where ReportConfig.REPORTTYPE='FW_SEARCH'


alter table ReportBuildingBlockParams_Temp ADD TEMPID bigint IDENTITY NOT NULL;
update ReportBuildingBlockParams_Temp SET RBBPID=TEMPID;
alter table ReportBuildingBlockParams_Temp DROP COLUMN TEMPID;


IF NOT EXISTS (SELECT * FROM sysobjects WHERE name='ReportBuildingBlockParams_7400' AND xtype='U') SELECT * INTO ReportBuildingBlockParams_7400 FROM ReportBuildingBlockParams WHERE 1=0;
IF NOT EXISTS (SELECT * FROM sysobjects WHERE name='ReportBuildingBlockParams_7600' AND xtype='U') SELECT * INTO ReportBuildingBlockParams_7600 FROM ReportBuildingBlockParams WHERE 1=0;
INSERT INTO ReportBuildingBlockParams_7400 SELECT * FROM ReportBuildingBlockParams;	
INSERT INTO ReportBuildingBlockParams_7600 SELECT * FROM ReportBuildingBlockParams_Temp;	
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlockParams') TRUNCATE TABLE ReportBuildingBlockParams;
INSERT INTO ReportBuildingBlockParams SELECT * FROM ReportBuildingBlockParams_7600;
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlockParams_7600') DROP TABLE ReportBuildingBlockParams_7600;
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlockParams_Temp') DROP TABLE ReportBuildingBlockParams_Temp;




#########  ReportBuildingBlockColumn Handling #########

CREATE TABLE ReportBuildingBlockColumn_Temp ( "RBBCID" bigint DEFAULT NULL,  "RBBNAME" nvarchar(250) NOT NULL DEFAULT '', "COLUMNNAME" nvarchar(250) NOT NULL DEFAULT '', "TABLENAME" nvarchar(250) DEFAULT NULL, "COLORCOLUMN" nvarchar(50) DEFAULT NULL, "HANDLER" nvarchar(250) DEFAULT NULL);

bcp.exe ${dbName}.dbo.ReportBuildingBlockColumn_Temp IN ${location}/ReportBuildingBlockColumn_mssql_temp.txt -S ${dbServer} -U ${userName} -P "${pwd}" -t "|**|" -r "|**|**|" -c;

IF NOT EXISTS (SELECT * FROM sysobjects WHERE name='ReportBuildingBlockColumn_7400' AND xtype='U') SELECT * INTO ReportBuildingBlockColumn_7400 FROM ReportBuildingBlockColumn WHERE 1=0;
IF NOT EXISTS (SELECT * FROM sysobjects WHERE name='ReportBuildingBlockColumn_7600' AND xtype='U') SELECT * INTO ReportBuildingBlockColumn_7600 FROM ReportBuildingBlockColumn WHERE 1=0;
INSERT INTO ReportBuildingBlockColumn_7400 SELECT * FROM ReportBuildingBlockColumn;
IDENTITY HANDLING THRO FIREWALLPOSTPROCESS;
INSERT INTO ReportBuildingBlockColumn_7600 SELECT * FROM ReportBuildingBlockColumn_Temp;	
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlockColumn') TRUNCATE TABLE ReportBuildingBlockColumn;
INSERT INTO ReportBuildingBlockColumn SELECT * FROM ReportBuildingBlockColumn_7600;	
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlockColumn_7600') DROP TABLE ReportBuildingBlockColumn_7600;
IF EXISTS(SELECT * FROM sysobjects WHERE name='ReportBuildingBlockColumn_Temp') DROP TABLE ReportBuildingBlockColumn_Temp;

#########  RBBGraphOptions Handling #########

IF NOT EXISTS (SELECT * FROM sysobjects WHERE name='RBBGraphOptions_Temp' AND xtype='U') SELECT * INTO RBBGraphOptions_Temp FROM RBBGraphOptions WHERE 1=0;

bcp.exe ${dbName}.dbo.RBBGraphOptions_Temp IN ${location}/RBBGraphOptions_mssql_temp.txt -S ${dbServer} -U ${userName} -P "${pwd}" -t "|**|" -r "|**|**|" -c; 

IF NOT EXISTS (SELECT * FROM sysobjects WHERE name='RBBGraphOptions_7400' AND xtype='U') SELECT * INTO RBBGraphOptions_7400 FROM RBBGraphOptions WHERE 1=0;
IF NOT EXISTS (SELECT * FROM sysobjects WHERE name='RBBGraphOptions_7600' AND xtype='U') SELECT * INTO RBBGraphOptions_7600 FROM RBBGraphOptions WHERE 1=0;
INSERT INTO RBBGraphOptions_7400 select * FROM RBBGraphOptions;
INSERT INTO RBBGraphOptions_7600 select * FROM RBBGraphOptions_Temp;	
IF EXISTS(SELECT * FROM sysobjects WHERE name='RBBGraphOptions') TRUNCATE TABLE RBBGraphOptions;
INSERT INTO RBBGraphOptions select * FROM RBBGraphOptions_7600;
insert into RBBGraphOptions select RBBNAME, GRAPHTYPE, XCOLUMN, YCOLUMN, XLABEL, YLABEL, LINKINGRBBNAME, LINKINGRBBGNAME, MCOLUMN, CRITERIA from RBBGraphOptions_7400 where (RBBNAME like '% Graph' OR RBBNAME like '% Table%' OR RBBNAME like '%_anomaly') and (RBBNAME not like 'Event Distribution Graph');
IF EXISTS(SELECT * FROM sysobjects WHERE name='RBBGraphOptions_7600') DROP TABLE RBBGraphOptions_7600;
IF EXISTS(SELECT * FROM sysobjects WHERE name='RBBGraphOptions_Temp') DROP TABLE RBBGraphOptions_Temp;


######### DROP TRIGGERs ########################
IF EXISTS(SELECT name FROM sysobjects WHERE name='ReportBuildingBlock_Trigger' AND type = 'TR') DROP TRIGGER ReportBuildingBlock_Trigger;
IF EXISTS(SELECT name FROM sysobjects WHERE name='ReportBuildingBlock_ReportBuildingBlock_UK0' AND type = 'TR') DROP TRIGGER ReportBuildingBlock_ReportBuildingBlock_UK0;
IF EXISTS(SELECT name FROM sysobjects WHERE name='ReportBuildingBlockColumn_Trigger' AND type = 'TR') DROP TRIGGER ReportBuildingBlockColumn_Trigger;
IF EXISTS(SELECT name FROM sysobjects WHERE name='RBBColumnOptions_RBBColumnOptions_UK0' AND type = 'TR') DROP TRIGGER RBBColumnOptions_RBBColumnOptions_UK0;



######### RECREATE CONSTRAINTs ##################
ALTER TABLE ReportBuildingBlock ADD CONSTRAINT ReportBuildingBlock_FK1 FOREIGN KEY (RBBGID) REFERENCES ReportBuildingBlockGroup (RBBGID) ON DELETE CASCADE;
ALTER TABLE ReportConfigToRBBMapping ADD CONSTRAINT ReportConfigToRBB_FK2 FOREIGN KEY (RBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE;
ALTER TABLE ReportConfigToRBBPMapping ADD CONSTRAINT ReportConfigToRBBP_FK2 FOREIGN KEY (RBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE;
ALTER TABLE ReportBuildingBlockParams ADD CONSTRAINT ReportBuildingBlockParams_FK1 FOREIGN KEY (RBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE;
ALTER TABLE ReportBuildingBlockColumn ADD CONSTRAINT ReportBuildingBlockColumn_FK FOREIGN KEY (RBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE;
ALTER TABLE RBBGraphOptions ADD CONSTRAINT RBBGraphOptions_FK1 FOREIGN KEY (RBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE;
ALTER TABLE RBBGraphOptions ADD CONSTRAINT RBBGraphOptions_FK2 FOREIGN KEY (LINKINGRBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE NO ACTION;

ALTER TABLE RBBColumnOptions ADD CONSTRAINT RBBColumnOptions_FK FOREIGN KEY (RBBCID) REFERENCES ReportBuildingBlockColumn (RBBCID) ON DELETE CASCADE;
ALTER TABLE AFToRBB ADD CONSTRAINT AFToRBB_FK2 FOREIGN KEY (RBBNAME) REFERENCES ReportBuildingBlock (RBBNAME) ON DELETE CASCADE;



######### RECREATE TRIGGERs #####################
CREATE TRIGGER ReportBuildingBlock_Trigger ON ReportBuildingBlock FOR delete AS BEGIN delete FROM ReportBuildingBlockParams WHERE RBBNAME IN (select RBBNAME FROM DELETED) delete FROM RBBGraphOptions WHERE RBBNAME IN (select RBBNAME FROM DELETED) delete FROM RBBGraphOptions WHERE LINKINGRBBNAME IN (select RBBNAME FROM DELETED) delete FROM ReportBuildingBlockColumn WHERE RBBNAME IN (select RBBNAME FROM DELETED) delete FROM ReportConfigToRBBPMapping WHERE RBBNAME IN (select RBBNAME FROM DELETED) delete FROM ReportConfigToRBBMapping WHERE RBBNAME IN (select RBBNAME FROM DELETED) delete FROM AFToRBB WHERE RBBNAME IN (select RBBNAME FROM DELETED) delete FROM ReportBuildingBlock WHERE RBBNAME IN (select RBBNAME FROM DELETED) END;

CREATE TRIGGER ReportBuildingBlock_ReportBuildingBlock_UK0 ON ReportBuildingBlock  FOR UPDATE,INSERT AS IF EXISTS (SELECT * FROM Inserted AS I JOIN ReportBuildingBlock AS S ON I.ORDERID= S.ORDERID AND NOT( ( I.RBBNAME = S.RBBNAME))) BEGIN ROLLBACK TRAN RAISERROR('Duplicate values not permitted',16,1) END;

CREATE TRIGGER ReportBuildingBlockColumn_Trigger on ReportBuildingBlockColumn FOR DELETE AS BEGIN DELETE FROM RBBColumnOptions WHERE RBBCID IN (select RBBCID FROM DELETED) delete FROM ReportBuildingBlockColumn WHERE RBBCID IN (select RBBCID FROM DELETED) END;

CREATE TRIGGER RBBColumnOptions_RBBColumnOptions_UK0 ON RBBColumnOptions FOR UPDATE,INSERT AS IF EXISTS (SELECT * FROM Inserted AS I JOIN RBBColumnOptions AS S ON I.ORDERID= S.ORDERID AND NOT( ( I.RBBCID = S.RBBCID) AND  ( I.VALUE = S.VALUE))) BEGIN ROLLBACK TRAN RAISERROR('Duplicate values not permitted',16,1) END;



#########  7600 ALTER TABLE Handling #########


insert into SystemConfigurations values ('indexTrafficLog','false');
alter table FAArchivedFiles ADD INDEXALL_STATUS bigint NOT NULL DEFAULT '0';

alter table ImportedLogs add FTPPORT int;
update ImportedLogs set FTPPORT=21 where LOG_TYPE like 'remote';
update SystemConfigurations SET CONF_VALUE='10' where CONF_NAME='pdfRowCount' AND CONF_VALUE=100;


IF EXISTS(SELECT * FROM sysobjects WHERE name='mapDummy') DROP TABLE mapDummy;
select LoginToDomainMapping.LOGINID,DiscoveredDomains.NAME INTO mapDummy from LoginToDomainMapping inner join DiscoveredDomains on LoginToDomainMapping.DOMAINID=DiscoveredDomains.DID;
update AaaLogin set DOMAINNAME=(select mapDummy.NAME from mapDummy where AaaLogin.LOGIN_ID=mapDummy.LOGINID) where EXISTS (select mapDummy.NAME from mapDummy where AaaLogin.LOGIN_ID=mapDummy.LOGINID);

INSERT INTO AAARadiusConfig SELECT RADIUS_IP,RADIUS_AUTH_PORT,AUTH_TYPE,RADIUS_SECRET,AUTH_RETRIES FROM RadiusServerSettings;
INSERT INTO ActiveDirectoryInfo(AD_ID,SERVERNAME,DEFAULTDOMAIN,USERNAME,PASSWORD) SELECT AD_ID,SERVERNAME,DEFAULTDOMAIN,USERNAME,PASSWORD FROM LAActiveDirectoryInfo;

update TaskEngine_Task set CLASS_NAME='com.me.tools.zcutil.mickeylite.MickeLiteZCSchedule' where TASK_NAME='METrackWorkFlow';

DROP INDEX ReportBuildingBlockGroup.ReportBuildingBlockGroup_IDX0;
DROP INDEX Bookmark.Bookmark_IDX1;
DROP INDEX Portlet.Portlet_IDX1;

ALTER TABLE ReportBuildingBlockGroup DROP COLUMN CRID;
ALTER TABLE Bookmark DROP COLUMN CRID;
ALTER TABLE Portlet DROP COLUMN CRID;


#########  ALL TIME NEED QUERY #########

update SeqGenState set CURRENTBATCHEND=CURRENTBATCHEND+300 where SEQNAME='ReportBuildingBlock.ORDERID';
update SeqGenState set CURRENTBATCHEND=CURRENTBATCHEND+300 where SEQNAME='ReportBuildingBlockParams.RBBPID';
update SeqGenState set CURRENTBATCHEND=CURRENTBATCHEND+300 where SEQNAME='ReportBuildingBlockColumn.RBBCID';

