#!/bin/bash


HOME_DIR=$PWD/..

JAVA_HOME=$HOME_DIR/jre

JAVA=$JAVA_HOME/bin/java

CHERRY_HOME=$HOME_DIR/conf/server.xml

DRIVER_CLASSES=$HOME_DIR/lib/mysql_connector.jar:$HOME_DIR/lib/jtds-1.2.jar

CLASS_PATH=$DRIVER_CLASSES:$HOME_DIR/lib/AdvPersistence.jar:$HOME_DIR/lib/run.jar:$HOME_DIR/lib/framework-tools.jar:$HOME_DIR/lib/jboss-jca.jar:$HOME_DIR/lib/jboss-compressed.jar:$HOME_DIR/lib/jboss-common-jdbc-wrapper.jar:$HOME_DIR/lib/concurrent.jar:$HOME_DIR/lib/jboss-transaction.jar:$HOME_DIR/lib/rt.jar:$HOME_DIR/lib/:$HOME_DIR/lib/:$HOME_DIR/lib/::$HOME_DIR/lib/LAClientUtil.jar:$HOME_DIR/lib/AdventNetInstallUtil.jar:$HOME_DIR/jre/lib/rt.jar:$HOME_DIR/lib/HTTPClient.jar:$HOME_DIR/lib/jboss-j2ee.jar:$HOME_DIR/lib/LogAnalyzerServer.jar:$HOME_DIR/lib/mickey3.jar:


JAVA_OPTS="-Ddb.home=$HOME_DIR/mysql -Dos.name=Linux"

JAVA_OPTS="$JAVA_OPTS -DseparateJVM=true -Dserver.home=$HOME_DIR -Dfile.encoding=utf8"

echo "************************************************************"
echo "		BackUp Database setup wizard"
echo "************************************************************"
echo ""
echo ""
echo "USAGE: backUpDatabase.sh <Backup_Directory_Path>"
echo ""
echo ""

Cancel()
{
	#cd tools
	exit 1
}


# -------------------------------------------------------------------------
# check the server status
# -------------------------------------------------------------------------

backup_dir=$1

if test "$1"==""
then
	echo "Database backup will be taken in the default path '$HOME_DIR/backup'. Do you still want to continue (y/n)?"
	read input
	if [ "$input" = "n" ]
	then
		echo "Enter the path location for backup:"
		read dir
		backup_dir=$dir
	fi
fi

. ../troubleshooting/serverStatus.sh

#-------------------------------------------------------------------------
# Backup Database
# -------------------------------------------------------------------------

echo $backup_dir

$JAVA $JAVA_OPTS -Xms128m -Xmx512m -Dtier-type=BE -Dtier-id=BE1 -DbackupDir=$backup_dir/backup -Dconsole=true -cp "$CLASS_PATH" com.adventnet.la.tools.BackUp

Cancel
