@echo off
rem $Id$

rem -----------------------------------------------------------------------------
rem check the server status
rem -----------------------------------------------------------------------------
call .\..\bin\setCommonEnv.bat

:START
echo Please take backup of mysql data folder before running this script.
set /P DO_PROCESS=Do you really want to continue this script? [y/n]: 
if "%DO_PROCESS%" NEQ "y" goto END
set DB_HOME=%DB_HOME%
set DB_PORT=33336
set DB_USER=root
set DB_HOST=localhost
set PASSWORD=""
set DB_NAME=firewall
set errmsg="Firewall Analyzer Server is running. Server should not run while running this tool. Please shutdown the server before running this tool."

cd ..
set HOME_DIR=%CD%
set ENT_FILE=%HOME_DIR%\enterprise.txt
set JAVA_HOME=%HOME_DIR%\jre

set CHERRY_HOME=%HOME_DIR%\conf\server.xml
set UTIL_CLASSPATH=%HOME_DIR%\lib\LAClientUtil.jar;%HOME_DIR%\lib\HTTPClient.jar
set JAVA=%JAVA_HOME%\bin\java

set ERRORLEVEL=
%JAVA% -Dserver.home=%HOME_DIR% -cp %UTIL_CLASSPATH% com.adventnet.la.util.LAClientUtil %CHERRY_HOME% 1
set e=%ERRORLEVEL%
if %e% NEQ -2  goto ERRMSG

goto CreateEnterpriseTxt



rem -------------------------------------------------------------------------
rem Give Warning Message about the Server run
rem ------------------------------------------------------------------------
:ERRMSG
cd troubleshooting
echo %errmsg%
goto END



rem -------------------------------------------------------------------------
rem Creating enterprise.txt file
rem ------------------------------------------------------------------------

:CreateEnterpriseTxt
cd %HOME_DIR%\troubleshooting
if EXIST %HOME_DIR%\enterprise.txt goto RegisterWithAdmin

set /P MY_WEB_PORT=Enter Web Port of this server [8500] :
set /P MY_WEB_PROTO=Enter Web Server Protocol of this server [http] :
set /P ADMIN_NAME=Enter Admin Server Name/IPAddress :
if "%ADMIN_NAME%" == "" goto PRINTERROR
set /P ADMIN_WEB_PORT=Enter Admin Server Web Port [8500] :
set /P ADMIN_WEB_PROTO=Enter Admin Server Web Protocol [http] :

if "%MY_WEB_PORT%" == "" set MY_WEB_PORT=8500
if "%MY_WEB_PROTO%" == "" set MY_WEB_PROTO=http
if "%ADMIN_WEB_PORT%" == "" set ADMIN_WEB_PORT=8500
if "%ADMIN_WEB_PROTO%" == "" set ADMIN_WEB_PROTO=http

echo context=fw>>%ENT_FILE%
echo server.type=DS>>%ENT_FILE%
echo webserver.port=%MY_WEB_PORT%>>%ENT_FILE%
echo webserver.protocol=%MY_WEB_PROTO%>>%ENT_FILE%
echo adminserver.hostname=%ADMIN_NAME%>>%ENT_FILE%
echo adminserver.webserver.port=%ADMIN_WEB_PORT%>>%ENT_FILE%
echo adminserver.webserver.protocol=%ADMIN_WEB_PROTO%>>%ENT_FILE%

echo isConverted=true>>%ENT_FILE%

set /P PROXY_NEEDED=Use Proxy to reach Admin server [n/y] :
if "%PROXY_NEEDED%" NEQ "y" goto RegisterWithAdmin

set /P PROXY_HOST=Enter Proxy Server Name :
set /P PROXY_PORT=Enter Proxy Server Port :
set /P PROXY_UNAME=Enter Proxy UserName :
set /P PROXY_PASSW=Enter Proxy Password :

if "%PROXY_HOST%" NEQ "" (if "%PROXY_PORT%" NEQ "" (if "%PROXY_UNAME%" NEQ "" (if "%PROXY_PASSW%" NEQ "" (goto WRITEPROXYINFO))))
goto RegisterWithAdmin


:PRINTERROR
echo Value should not be empty
goto END


:WRITEPROXYINFO
echo proxy.host=%PROXY_HOST%>>%ENT_FILE%
echo proxy.port=%PROXY_PORT%>>%ENT_FILE%
echo proxy.username=%PROXY_UNAME%>>%ENT_FILE%
echo proxy.password=%PROXY_PASSW%>>%ENT_FILE%



rem -------------------------------------------------------------------------
rem Register this collector in Admin server
rem ------------------------------------------------------------------------
:RegisterWithAdmin
rem call %HOME_DIR%\troubleshooting\registerWithAdminServer.bat
set REGISTER_CLASSPATH=%HOME_DIR%\lib\HTTPClient.jar;%HOME_DIR%\lib\EnterpriseStartUP.jar;%HOME_DIR%\lib\AdvPersistence.jar
%JAVA% -Dserver.home=%HOME_DIR% -cp %REGISTER_CLASSPATH% com.adventnet.la.enterprise.EnterpriseStartUpUtil %HOME_DIR% converted
goto ExecuteUpdateQueries



rem -------------------------------------------------------------------------
rem Execute Convertion query
rem ------------------------------------------------------------------------

:ExecuteUpdateQueries
set DRIVER_CLASSES=%HOME_DIR%\lib\mysql_connector.jar;%HOME_DIR%\lib\jtds-1.2.jar;%HOME_DIR%\lib\postgresql_jdbc3.jar;%HOME_DIR%\lib\postgresql_jdbc4.jar

set My_CLASSPATH=%DRIVER_CLASSES%;%HOME_DIR%\lib\EnterpriseStartUp.jar;%HOME_DIR%\lib\AdvPersistence.jar;%HOME_DIR%\lib\LAClientUtil.jar;%HOME_DIR%\lib\run.jar;%HOME_DIR%\lib\framework-tools.jar;%HOME_DIR%\lib\jboss-j2ee.jar;%HOME_DIR%\lib\jboss-jca.jar;%HOME_DIR%\lib\jboss-compressed.jar;%HOME_DIR%\lib\jboss-common-jdbc-wrapper.jar;%HOME_DIR%\lib\concurrent.jar;%HOME_DIR%\lib\jboss-transaction.jar;%HOME_DIR%\lib\mickey3.jar

set JAVA_OPTS=-Ddb.home=%DB_HOME% -DseparateJVM=true -Dserver.home=%HOME_DIR% -Xms256m -Xmx1024m
%JAVA% %JAVA_OPTS% -cp %My_CLASSPATH% com.adventnet.fa.server.enterprise.HandleCollectorConversion
goto ReplaceXmlFile



 
rem -------------------------------------------------------------------------
rem Replace nms-service_ds.xml into nms_service.xml
rem ------------------------------------------------------------------------
:ReplaceXmlFile
set UTIL_CLASS_PATH=%HOME_DIR%\lib\LAClientUtil.jar;%HOME_DIR%\lib\AdventNetUpdateManagerInstaller.jar;%HOME_DIR%\lib\HTTPClient.jar;%HOME_DIR%\lib\EnterpriseStartUP.jar;%HOME_DIR%\lib\AdvPersistence.jar

%JAVA% -Dserver.home=%HOME_DIR% -cp %UTIL_CLASS_PATH% com.adventnet.la.tools.EEInstallChanges 1
goto END


rem -------------------------------------------------------------------------
rem Cleanup all variables
rem ------------------------------------------------------------------------

:END
set ENT_FILE=
set DB_HOME=
set DB_PORT=
set DB_USER=
set DB_HOST=
set PASSWORD=
set DB_NAME=
set HOME_DIR=
set JAVA_HOME=
set CHERRY_HOME=
set UTIL_CLASSPATH=
set JAVA=
set MY_WEB_PORT=
set MY_WEB_PROTO=
set ADMIN_NAME=
set ADMIN_WEB_PORT=
set ADMIN_WEB_PROTO=
set MY_CLASSPATH=
