#!/bin/sh

#ENT_FILE=../enterprise.txt
. ../bin/setCommonEnv.sh

PROD_HOME="`pwd`/.."
ENT_FILE=$PROD_HOME/enterprise.txt
DB_HOME=$DB_HOME
DB_PORT=33336
USER_NAME=root
DB_HOST=127.0.0.1
DB_NAME=firewall
PASSWORD=""

checkServerStatus()
{
echo "Please take backup of mysql data folder before running this script."
read -p "Do you really want to continue this script? [y/n]: " DO_PROCESS
if [ "$DO_PROCESS" != "y" ];then
	exit
fi

msg="Firewall Analyzer Server is running. Server should not run while running this tool. Please shutdown the server before running this tool."

TOOL_HOME=$PWD
BIN_HOME=../bin
JAVA_HOME=../jre
CHERRY_HOME=../conf/server.xml
UTIL_CLASSPATH=../lib/LAClientUtil.jar:../lib/HTTPClient.jar
JAVA=$JAVA_HOME/bin/java

export JAVA_HOME
export TOOL_HOME
export BIN_HOME
export UTIL_CLASSPATH
export JAVA
export CHERRY_HOME


                $JAVA -DContext=fw -Dserver.home=$PROD_HOME -cp $UTIL_CLASSPATH com.adventnet.la.util.LAClientUtil $CHERRY_HOME 1

                if [ $? -ne 254 ]
                then
                        echo $msg
                        exit 1
                else
                        echo ""
                fi

}


constructEnterpriseFile()
{

if [ -f $ENT_FILE ]; then
	#rm -rf $ENT_FILE
	return
fi
CONTEXT="context=fw"
TYPE="server.type=DS"
DEF_PORT="8500"
DEF_PROTO="http"
read -p "Enter Web Port of this server [8500] :" MY_WEB_PORT
read -p "Enter Web Server Protocol of this server [http] :" MY_WEB_PROTO
read -p "Enter Admin Server Name/IPAddress :" ADMIN_NAME

while [ "$ADMIN_NAME" = "" ]
do
	echo "Admin Server Name/IPAddress should not be empty"
	read -p "Enter Admin Server Name/IPAddress :" ADMIN_NAME
done

read -p "Enter Admin Server Web Port [8500] :" ADMIN_WEB_PORT
read -p "Enter Admin Server Web Protocol [http] :" ADMIN_WEB_PROTO

if [ "$MY_WEB_PORT" = "" ];then
	MY_WEB_PORT=$DEF_PORT
fi

if [ "$MY_WEB_PROTO" = "" ];then
	MY_WEB_PROTO=$DEF_PROTO
fi

if [ "$ADMIN_WEB_PORT" = "" ];then
	ADMIN_WEB_PORT=$DEF_PORT
fi

if [ "$ADMIN_WEB_PROTO" = "" ];then
	ADMIN_WEB_PROTO=$DEF_PROTO
fi


echo $CONTEXT>>$ENT_FILE
echo $TYPE>>$ENT_FILE
echo "webserver.port="$MY_WEB_PORT>>$ENT_FILE
echo "webserver.protocol="$MY_WEB_PROTO>>$ENT_FILE
echo "adminserver.hostname="$ADMIN_NAME>>$ENT_FILE
echo "adminserver.webserver.port="$ADMIN_WEB_PORT>>$ENT_FILE
echo "adminserver.webserver.protocol="$ADMIN_WEB_PROTO>>$ENT_FILE

read -p "Use Proxy to reach Admin server [n/y] :" USE_PROXY
if [ "$USE_PROXY" = "y" ];then
	read -p "Enter Proxy Server Name :" PROXY_HOST
	read -p "Enter Proxy Server Port :" PROXY_PORT
	read -p "Enter Proxy UserName :" PROXY_UNAME
	read -p "Enter Proxy Password :" PROXY_PASSW
	if [ "$PROXY_HOST" != "" -a "$PROXY_PORT" != "" -a "$PROXY_UNAME" != "" -a "$PROXY_PASSW" != "" ];then
		echo "proxy.host="$PROXY_HOST>>$ENT_FILE
		echo "proxy.port="$PROXY_PORT>>$ENT_FILE
		echo "proxy.username="$PROXY_UNAME>>$ENT_FILE
		echo "proxy.password="$PROXY_PASSW>>$ENT_FILE
	fi
fi

echo "isConverted=true">>$ENT_FILE

#check whether the file created with appropriate access
if [ ! -f $ENT_FILE ]; then
	echo "$ENT_FILE : does not exists"
  	exit 1
elif [ ! -r $ENT_FILE ]; then
  	echo "$ENT_FILE: can not read"
  	exit 2
fi
}


registerWithAdmin()
{
#. ./registerWithAdminServer.sh
#. ../bin/setcommonenv.sh
CLASSPATH=$PROD_HOME/lib/HTTPClient.jar:$PROD_HOME/lib/EnterpriseStartUp.jar:$PROD_HOME/lib/AdvPersistence.jar

$PROD_HOME/jre/bin/java -Dserver.home=$PROD_HOME -classpath $CLASSPATH com.adventnet.la.enterprise.EnterpriseStartUpUtil $PROD_HOME converted
}


startMySQL()
{
SOCK_HOME="${DB_HOME}/tmp"
chmod -R u+x $DB_HOME
$DB_HOME/bin/mysqld --no-defaults --basedir=$DB_HOME --port=$DB_PORT --socket=$SOCK_HOME/mysql.sock --user=$USER_NAME &
}


stopMySQL()
{
SOCK_HOME=${DB_HOME}/tmp/mysql.sock

commandArgs="-S $SOCK_HOME -P $DB_PORT -u $USER_NAME"

if [ -n "$PASSWORD" ]
then
     commandArgs="$commandArgs -p $PASSWORD"
fi

$DB_HOME/bin/mysqladmin $commandArgs shutdown

}

executeUpdateQueries()
{
DRIVER_CLASSES=$PROD_HOME/lib/mysql_connector.jar:$PROD_HOME/lib/jtds-1.2.jar:$PROD_HOME/lib/postgresql_jdbc3.jar:$PROD_HOME/lib/postgresql_jdbc4.jar
CLASSPATH=$PROD_HOME/lib/EnterpriseStartUp.jar:$PROD_HOME/lib/mysql_connector.jar:$PROD_HOME/lib/activation.jar:$PROD_HOME/lib/AdvPersistence.jar:$PROD_HOME/lib/LAClientUtil.jar:$PROD_HOME/lib/run.jar:$PROD_HOME/lib/framework-tools.jar:$PROD_HOME/lib/jboss-j2ee.jar:$PROD_HOME/lib/jboss-jca.jar:$PROD_HOME/lib/jboss-compressed.jar:$PROD_HOME/lib/jboss-common-jdbc-wrapper.jar:$PROD_HOME/lib/concurrent.jar:$PROD_HOME/lib/jboss-transaction.jar:$PROD_HOME/lib/mickey3.jar:$DRIVER_CLASSES
#export CLASSPATH

$PROD_HOME/jre/bin/java -Ddb.home=$DB_HOME -DseparateJVM=true -Dserver.home=$PROD_HOME -classpath $CLASSPATH com.adventnet.fa.server.enterprise.HandleCollectorConversion -Xms256m -Xmx1024m
}

replaceXmlFile()
{
CLASSPATH=$PROD_HOME/lib/LAClientUtil.jar:$PROD_HOME/lib/AdventNetUpdateManagerInstaller.jar:$PROD_HOME/lib/HTTPClient.jar:$PROD_HOME/lib/EnterpriseStartUp.jar:$PROD_HOME/lib/AdvPersistence.jar

$PROD_HOME/jre/bin/java -Dserver.home=$PROD_HOME -classpath $CLASSPATH com.adventnet.la.tools.EEInstallChanges 1
}

main()
{
	checkServerStatus;
	constructEnterpriseFile;
	registerWithAdmin;
	executeUpdateQueries;
	replaceXmlFile;
}

main $*
