rem @echo off
rem $Id$
call ..\bin\setCommonEnv.bat

echo =================================================================
echo .
echo Usage : DBInfo.bat [DatabaseType] [ServerName] [DatabaseName] [AuthenticationType true/false] [DBPort] [UserName] [Password]
echo .
echo =================================================================

set TABLELIST=datatables.list
set TEMPFILE=temp.list
set LOGFILE=databaseinfo.log
set BUILDFILE=build.properties
set SYSINFOFILE=sysinfo.log
set DBType="%1"
set SERVERNAME="%2"
set DBNAME=%3
set isWinAuthType="%4"
set PORT="%5"
set USERNAME="%6"
set PASSWORD="%7"
set MYSQLEXE=..\mysql\bin\mysql
set MYSQLSTRING=%MYSQLEXE% -u %USERNAME% --password=%PASSWORD% -P %PORT% %DBNAME%
if %PASSWORD% == "" set MYSQLSTRING=%MYSQLEXE% -u %USERNAME% -P %PORT% %DBNAME%

if %DBType% == "mssql" goto MSSQL_PARAMS else (
if %DBType% == "postgres" goto PGSQL_PARAMS 
) else (
goto SET_ENV
)


rem -------------------------------------------------------------------------
rem Set the parameters for PGSQL
rem -------------------------------------------------------------------------
:PGSQL_PARAMS
set MYSQLSTRING=%DB_HOME%\bin\psql -U %USERNAME% --password=%PASSWORD% -p %PORT% %DBNAME%
if %PASSWORD% == "" set MYSQLSTRING=%DB_HOME%\bin\psql -U %USERNAME% -p %PORT% %DBNAME%
goto SET_ENV

rem -------------------------------------------------------------------------
rem Set the parameters for MSSQL
rem -------------------------------------------------------------------------

:MSSQL_PARAMS
set BCPEXE=..\mysql\bin\bcp
set BCPSTRING=-S %SERVERNAME% -U %USERNAME% -P %PASSWORD% -c
if %isWinAuthType% == "true" set BCPSTRING=-S %SERVERNAME% -T  -c
if %PASSWORD% == "" set BCPSTRING=-S %SERVERNAME% -U %USERNAME% -P  -c
goto SET_ENV

:SET_ENV

rem -------------------------------------------------------------------------
rem Set the Error Message for DBInfo
rem -------------------------------------------------------------------------

set errmsg="Firewall Analyzer Server is not running. Please ensure that the Firewall Analyzer Server should run before running this script"

rem -------------------------------------------------------------------------
rem check the server status
rem -------------------------------------------------------------------------

set JAVA_HOME=..\jre
set TOOL_HOME=.\
set BUILD_HOME=..\troubleshooting
set LOG_DIR=..\logs
set CHERRY_HOME=..\conf\server.xml
set UTIL_CLASSPATH=..\lib\LAClientUtil.jar;..\lib\HTTPClient.jar
set JAVA=%JAVA_HOME%\bin\java


set ERRORLEVEL=
%JAVA% -Dserver.home=..\ -cp %UTIL_CLASSPATH% com.adventnet.la.util.LAClientUtil %CHERRY_HOME% 1
set e=%ERRORLEVEL%
if %e% EQU -2  goto ERRMSG
rem if not exist %LOCKFILE% goto ERRMSG


rem -------------------------------------------------------------------------
rem removing the old log file
rem -------------------------------------------------------------------------
if exist %LOGFILE% del %LOGFILE% 
 
rem -------------------------------------------------------------------------
rem removing the old table list file
rem -------------------------------------------------------------------------
if exist %TABLELIST% del %TABLELIST% 

rem -------------------------------------------------------------------------
rem removing the old temp file
rem -------------------------------------------------------------------------
if exist %TEMPFILE% del %TEMPFILE% 

if %DBType% == "mssql" goto MSSQL_TABLEINFO else (
if %DBType% == "postgres" goto PGSQL_TABLEINFO
) else (
goto MYSQL_SELECTTABLES
)

:PGSQL_TABLEINFO
rem -------------------------------------------------------------------------
rem Selecting the tables
rem ------------------------------------------------------------------------
echo select LOOKUP_TABLENAME from MetaTable | %MYSQLSTRING% >> %TEMPFILE%
echo ------------------------------------------------------------------------
echo Database Information 
echo ------------------------------------------------------------------------
echo %date%-%time% >> %LOGFILE% 2>&1
echo =========================================>> %LOGFILE% 2>&1
echo PostgreSQL Version >> %LOGFILE% 2>&1
call :GETVERSION
echo =========================================>> %LOGFILE% 2>&1
goto GETDATA


rem -------------------------------------------------------------------------
rem MySQL queries handled here
rem -------------------------------------------------------------------------

rem -------------------------------------------------------------------------
rem Selecting the tables
rem ------------------------------------------------------------------------
:MYSQL_SELECTTABLES
echo select LOOKUP_TABLENAME from MetaTable | %MYSQLSTRING% >> %TEMPFILE%
goto REWRITE

rem -------------------------------------------------------------------------
rem Removing the first entry from the temp.list file and creating new file.
rem then proceed to removetables.
rem ------------------------------------------------------------------------
:REWRITE
rem findstr /V "LOOKUP_TABLENAME" %TEMPFILE% >> %TABLELIST%
goto DBINFO 


rem -------------------------------------------------------------------------
rem Processing the tables list to get count
rem ------------------------------------------------------------------------
:DBINFO
echo ------------------------------------------------------------------------
echo Database Information 
echo ------------------------------------------------------------------------
echo %date%-%time% >> %LOGFILE% 2>&1
echo =========================================>> %LOGFILE% 2>&1
echo MySQL Version >> %LOGFILE% 2>&1
call :GETVERSION
echo =========================================>> %LOGFILE% 2>&1

:GETDATA
call :GETCOUNT FirewallRecords LRID
call :GETCOUNT SquidRecords SQID
call :GETCOUNT RadiusRecords RASID
call :GETLASTEST FirewallRecords LRID
call :GETLASTEST SquidRecords SQID
call :GETLASTEST RadiusRecords RASID
call :GETCOMPLETETABLE MetaTable
call :GETCOMPLETETABLE Resources
call :GETCOMPLETETABLE ImportedLogs
call :GETCOMPLETETABLE UnParsedRecords
call :GETCOMPLETETABLE FAArchivedFiles
call :GETCOMPLETETABLE Schedule
call :GETCOMPLETETABLE NotificationFilters
call :GETCOMPLETETABLE ReportConfig
call :GETCOMPLETETABLE ReportConfigToDF
call :GETCOMPLETETABLE ReportConfigToFilters
call :GETCOMPLETETABLE FilterToLAExpression
call :GETCOMPLETETABLE LAExpression
call :GETCOMPLETETABLE Collectors
call :GETCOMPLETETABLE DataCollectionStatus
call :GETDBSIZE

rem goto COPY_LOG_FILES

rem -----------------------------------------------------------------------------
rem Create sysinfofile and copy it into log file
rem -----------------------------------------------------------------------------
if not exist %LOG_DIR%\%SYSINFOFILE% systeminfo > %LOG_DIR%\%SYSINFOFILE%

rem -----------------------------------------------------------------------------
rem Copy wrapper.log file into log directory
rem -----------------------------------------------------------------------------
set WRAPPERFILE=..\bin\wrapper.log
set WRAPPERLOG=..\logs\wrapper.log
if not exist "%WRAPPERLOG%" copy %WRAPPERFILE% %LOG_DIR%

rem -----------------------------------------------------------------------------
rem Copy Log.txt file into log directory [Update Manager]
rem -----------------------------------------------------------------------------
set UPDATEMGRFILE=..\logs\Log.txt
if exist "%UPDATEMGRFILE%" copy %UPDATEMGRFILE% %LOG_DIR%

rem -----------------------------------------------------------------------------
rem Copy pgsql_%a.log file into log directory
rem -----------------------------------------------------------------------------
set ENTERPRISEFILE=%DB_HOME%\data\pg_log\*.log
if exist "%ENTERPRISEFILE%" copy %ENTERPRISEFILE% %LOG_DIR%

rem -----------------------------------------------------------------------------
rem Copy enterprise.txt file into log directory
rem -----------------------------------------------------------------------------
set ENTERPRISEFILE=..\enterprise.txt
if exist "%ENTERPRISEFILE%" copy %ENTERPRISEFILE% %LOG_DIR%


rem -----------------------------------------------------------------------------
rem Copy databaseinfo.txt and build.properties files into log directory
rem -----------------------------------------------------------------------------
:COPY_LOG_FILES
copy %TOOL_HOME%\%LOGFILE%  %LOG_DIR%
copy %BUILD_HOME%\%BUILDFILE% %LOG_DIR%
goto STOP

rem -------------------------------------------------------------------------
rem get MySQL Version information
rem ------------------------------------------------------------------------
:GETVERSION
echo select version() | %MYSQLSTRING% >> %LOGFILE% 2>&1
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
goto STOP


rem -------------------------------------------------------------------------
rem getCount information
rem ------------------------------------------------------------------------
:GETCOUNT
echo %1 - %time%:%date%  >> %LOGFILE% 2>&1
echo select count(%2) from  %1 | %MYSQLSTRING% >> %LOGFILE% 2>&1
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
echo =========================================================================  >> %LOGFILE% 2>&1
echo Info obtained for  %1
goto STOP


rem -------------------------------------------------------------------------
rem getLimit information
rem ------------------------------------------------------------------------
:GETLIMIT
echo %1 - %time%:%date%  >> %LOGFILE% 2>&1
echo select * from  %1 limit 1 | %MYSQLSTRING% >> %LOGFILE% 2>&1
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
echo =========================================================================  >> %LOGFILE% 2>&1
echo Info obtained for  %1
goto STOP

rem -------------------------------------------------------------------------
rem getLast information
rem ------------------------------------------------------------------------
:GETLASTEST
echo %1 - %time%:%date%  >> %LOGFILE% 2>&1
echo select * from  %1 order by %2 DESC limit 1 | %MYSQLSTRING% >> %LOGFILE% 2>&1
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
echo =========================================================================  >> %LOGFILE% 2>&1
echo Info obtained for  %1
goto STOP


rem -------------------------------------------------------------------------
rem getComplete information
rem ------------------------------------------------------------------------
:GETCOMPLETETABLE
echo %1 - %time%:%date%  >> %LOGFILE% 2>&1
echo select * from  %1 | %MYSQLSTRING% >> %LOGFILE% 2>&1
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
echo =========================================================================  >> %LOGFILE% 2>&1
echo Info obtained for  %1
goto STOP



rem -------------------------------------------------------------------------
rem DBSize information
rem ------------------------------------------------------------------------
:GETDBSIZE
echo DataBase size  >> %LOGFILE% 2>&1
if %DBType% == "mysql" (
dir ..\mysql\data   >> %LOGFILE% 2>&1
copy ..\mysql\data\*.err %LOG_DIR% 
) else (
echo \l+ | %MYSQLSTRING% >> %LOGFILE% 2>&1
dir ..\pgsql\data   >> %LOGFILE% 2>&1
)
goto STOP


rem -------------------------------------------------------------------------
rem Error Message
rem ------------------------------------------------------------------------
:ERRMSG
echo %errmsg%
goto STOP

rem -------------------------------------------------------------------------
rem Error in dropping the table
rem ------------------------------------------------------------------------	 
:ERROR
echo %date%-%time% Unable to get count of  %1 >> %LOGFILE% 2>&1
echo -----------------------------------------------------------------------  >> %LOGFILE% 2>&1
goto STOP


rem -------------------------------------------------------------------------
rem MSSQL queries handled here
rem -------------------------------------------------------------------------
:MSSQL_TABLEINFO

rem -------------------------------------------------------------------------
rem Processing the tables list to get count
rem ------------------------------------------------------------------------
echo ------------------------------------------------------------------------
echo Database Information 
echo ------------------------------------------------------------------------
echo %date%-%time% >> %LOGFILE% 2>&1
echo =========================================>> %LOGFILE% 2>&1
echo MSSQL Version >> %LOGFILE% 2>&1
call :GET_MSSQL_VERSION
echo =========================================>> %LOGFILE% 2>&1
echo Raw table count values===================>> %LOGFILE% 2>&1

call :GETMSSQLCOUNT FirewallRecords LRID
call :GETMSSQLCOUNT SquidRecords SQID
call :GETMSSQLCOUNT RadiusRecords RASID
call :GETMSSQLLATEST FirewallRecords LRID
call :GETMSSQLLATEST FirewallRecords LRID
call :GETMSSQLLATEST SquidRecords SQID
call :GETMSSQLLATEST RadiusRecords RASID

echo Configuration table values===================>> %LOGFILE% 2>&1

call :GETMSSQLCOMPLETETABLE MetaTable
call :GETMSSQLCOMPLETETABLE Resources
call :GETMSSQLCOMPLETETABLE ImportedLogs
call :GETMSSQLCOMPLETETABLE UnParsedRecords
call :GETMSSQLCOMPLETETABLE FAArchivedFiles
call :GETMSSQLCOMPLETETABLE Schedule
call :GETMSSQLCOMPLETETABLE NotificationFilters
call :GETMSSQLCOMPLETETABLE ReportConfig
call :GETMSSQLCOMPLETETABLE ReportConfigToFilters
call :GETMSSQLCOMPLETETABLE ReportConfigToDF
call :GETMSSQLCOMPLETETABLE ReportConfigToDF
call :GETMSSQLCOMPLETETABLE FilterToLAExpression
call :GETMSSQLCOMPLETETABLE LAExpression
call :GETMSSQLCOMPLETETABLE Collectors
call :GETMSSQLCOMPLETETABLE DataCollectionStatus

goto COPY_LOG_FILES

rem -------------------------------------------------------------------------
rem get MSSQL Version information
rem ------------------------------------------------------------------------
:GET_MSSQL_VERSION
echo | %BCPEXE% "select @@version" queryout version.txt %BCPSTRING% 
copy %LOGFILE% + version.txt %LOGFILE% 2>&1
if exist version.txt del version.txt 
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
goto STOP


rem -------------------------------------------------------------------------
rem get MSSQL Count information
rem ------------------------------------------------------------------------
:GETMSSQLCOUNT
echo %1 - %time%:%date%  >> %LOGFILE% 2>&1
echo | %BCPEXE% "select count(%2) from  %DBNAME%.dbo.%1" queryout %1.txt %BCPSTRING%
copy %LOGFILE% + %1.txt %LOGFILE% 2>&1
if exist %1.txt del %1.txt
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
echo -----------------------------------------------------------------------  >> %LOGFILE% 2>&1
echo Info obtained for  %1
goto STOP


rem -------------------------------------------------------------------------
rem get MSSQL Latest data from table information
rem ------------------------------------------------------------------------
:GETMSSQLLATEST
echo %1 - %time%:%date%  >> %LOGFILE% 2>&1
echo | %BCPEXE% "select TOP 1 * from  %DBNAME%.dbo.%1 order by %2 DESC" queryout %1.txt %BCPSTRING%
copy %LOGFILE% + %1.txt %LOGFILE% 2>&1
if exist %1.txt del %1.txt
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
echo -----------------------------------------------------------------------  >> %LOGFILE% 2>&1
echo Info obtained for  %1
goto STOP


rem -------------------------------------------------------------------------
rem get MSSQL Complete table information
rem ------------------------------------------------------------------------
:GETMSSQLCOMPLETETABLE
echo %1 - %time%:%date%  >> %LOGFILE% 2>&1
echo | %BCPEXE% "select * from  %DBNAME%.dbo.%1" queryout %1.txt %BCPSTRING%
copy %LOGFILE% + %1.txt %LOGFILE% 2>&1
if exist %1.txt del %1.txt
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
echo -----------------------------------------------------------------------  >> %LOGFILE% 2>&1
echo Info obtained for  %1
goto STOP


rem -------------------------------------------------------------------------
rem getMSSQL TOP value information
rem ------------------------------------------------------------------------
:GETMSSQLLIMIT
echo %1 - %time%:%date%  >> %LOGFILE% 2>&1
echo | %BCPEXE% "select TOP 1 * from  %DBNAME%.dbo.%1" queryout %1.txt %BCPSTRING%
copy %LOGFILE% + %1.txt %LOGFILE% 2>&1
if exist %1.txt del %1.txt
set ERRORLEVEL=%errorlevel%
if ERRORLEVEL 1 goto ERROR %1
echo -----------------------------------------------------------------------  >> %LOGFILE% 2>&1
echo Info obtained for  %1
goto STOP



echo =======================================================================>> %LOGFILE% 2>&1
:COMPLETED
echo ------------------------------------------------------------------------
echo COMPLETED. See %LOGFILE% for more details
echo ------------------------------------------------------------------------

:STOP
